=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2010-08-10 18:09:11 +0000
+++ plugin/myisam/ha_myisam.cc	2010-08-11 16:49:34 +0000
@@ -533,7 +533,6 @@
                         const char *sfile, uint32_t sline)
 {
   Session *cur_session;
-  pthread_mutex_lock(&file->s->intern_lock);
   if ((cur_session= file->in_use))
     errmsg_printf(ERRMSG_LVL_ERROR, _("Got an error from thread_id=%"PRIu64", %s:%d"),
                     cur_session->thread_id,
@@ -548,7 +547,6 @@
     errmsg_printf(ERRMSG_LVL_ERROR, "%s", _("Unknown thread accessing table"));
     ++it;
   }
-  pthread_mutex_unlock(&file->s->intern_lock);
 }
 
 ha_myisam::ha_myisam(plugin::StorageEngine &engine_arg,

=== modified file 'plugin/myisam/mi_close.cc'
--- plugin/myisam/mi_close.cc	2010-08-08 18:29:57 +0000
+++ plugin/myisam/mi_close.cc	2010-08-11 16:49:34 +0000
@@ -42,7 +42,6 @@
     if (mi_lock_database(info,F_UNLCK))
       error=errno;
   }
-  pthread_mutex_lock(&share->intern_lock);
 
   if (share->options & HA_OPTION_READ_ONLY_DATA)
   {
@@ -57,7 +56,6 @@
   }
   flag= !--share->reopen;
   myisam_open_list.remove(info);
-  pthread_mutex_unlock(&share->intern_lock);
 
   void * rec_buff_ptr= mi_get_rec_buff_ptr(info, info->rec_buff);
   if (rec_buff_ptr != NULL)
@@ -89,13 +87,11 @@
       free((unsigned char*) share->decode_tables);
     }
     share->lock.deinit();
-    pthread_mutex_destroy(&share->intern_lock);
     {
       int keys= share->state.header.keys;
       pthread_rwlock_destroy(&share->mmap_lock);
       for (int i= 0; i < keys; i++)
       {
-	pthread_rwlock_destroy(&share->key_root_lock[i]);
       }
     }
     delete info->s->in_use;

=== modified file 'plugin/myisam/mi_extra.cc'
--- plugin/myisam/mi_extra.cc	2010-08-08 04:21:53 +0000
+++ plugin/myisam/mi_extra.cc	2010-08-11 16:49:34 +0000
@@ -249,7 +249,6 @@
     share->last_version= 0L;			/* Impossible version */
 #ifdef __WIN__REMOVE_OBSOLETE_WORKAROUND
     /* Close the isam and data files as Win32 can't drop an open table */
-    pthread_mutex_lock(&share->intern_lock);
     if (flush_key_blocks(share->key_cache, share->kfile,
 			 (function == HA_EXTRA_FORCE_REOPEN ?
 			  FLUSH_RELEASE : FLUSH_IGNORE_CHANGED)))
@@ -290,7 +289,6 @@
       }
     }
     share->kfile= -1;				/* Files aren't open anymore */
-    pthread_mutex_unlock(&share->intern_lock);
 #endif
     pthread_mutex_unlock(&THR_LOCK_myisam);
     break;

=== modified file 'plugin/myisam/mi_info.cc'
--- plugin/myisam/mi_info.cc	2010-02-13 02:23:32 +0000
+++ plugin/myisam/mi_info.cc	2010-08-11 16:49:34 +0000
@@ -42,10 +42,8 @@
     return(0);				/* Compatible with ISAM */
   if (!(flag & HA_STATUS_NO_LOCK))
   {
-    pthread_mutex_lock(&share->intern_lock);
     _mi_readinfo(info,F_RDLCK,0);
     fast_mi_writeinfo(info);
-    pthread_mutex_unlock(&share->intern_lock);
   }
   if (flag & HA_STATUS_VARIABLE)
   {

=== modified file 'plugin/myisam/mi_locking.cc'
--- plugin/myisam/mi_locking.cc	2010-08-08 04:21:53 +0000
+++ plugin/myisam/mi_locking.cc	2010-08-11 16:49:34 +0000
@@ -36,13 +36,11 @@
   MYISAM_SHARE *share=info->s;
   uint32_t flag;
 
-  pthread_mutex_lock(&share->intern_lock);
   if (!info->s->in_use)
     info->s->in_use= new list<Session *>;
 
   if (lock_type == F_EXTRA_LCK)                 /* Used by TMP tables */
   {
-    pthread_mutex_unlock(&share->intern_lock);
     ++share->w_locks;
     ++share->tot_locks;
     info->lock_type= lock_type;
@@ -213,7 +211,6 @@
     }
   }
 #endif
-  pthread_mutex_unlock(&share->intern_lock);
 #if defined(FULL_LOG) || defined(_lint)
   lock_type|=(int) (flag << 8);		/* Set bit to set if real lock */
   myisam_log_command(MI_LOG_LOCK,info,(unsigned char*) &lock_type,sizeof(lock_type),

=== modified file 'plugin/myisam/mi_open.cc'
--- plugin/myisam/mi_open.cc	2010-08-08 04:21:53 +0000
+++ plugin/myisam/mi_open.cc	2010-08-11 16:49:34 +0000
@@ -247,7 +247,6 @@
            &share->state.key_root,keys*sizeof(uint64_t),
            &share->state.key_del,
            (share->state.header.max_block_size_index*sizeof(uint64_t)),
-           &share->key_root_lock,sizeof(pthread_rwlock_t)*keys,
            &share->mmap_lock,sizeof(pthread_rwlock_t),
            NULL))
       goto err;
@@ -390,9 +389,6 @@
     mi_setup_functions(share);
     share->is_log_table= false;
     thr_lock_init(&share->lock);
-    pthread_mutex_init(&share->intern_lock,MY_MUTEX_INIT_FAST);
-    for (i=0; i<keys; i++)
-      pthread_rwlock_init(&share->key_root_lock[i], NULL);
     pthread_rwlock_init(&share->mmap_lock, NULL);
     if (myisam_concurrent_insert)
     {
@@ -459,7 +455,6 @@
   info.bulk_insert=0;
   info.errkey= -1;
   info.page_changed=1;
-  pthread_mutex_lock(&share->intern_lock);
   info.read_record=share->read_record;
   share->reopen++;
   share->write_flag=MYF(MY_NABP | MY_WAIT_IF_FULL);
@@ -489,7 +484,6 @@
 
   share->delay_key_write= 1;
   info.state= &share->state.state;	/* Change global values by default */
-  pthread_mutex_unlock(&share->intern_lock);
 
   /* Allocate buffer for one record */
 

=== modified file 'plugin/myisam/mi_range.cc'
--- plugin/myisam/mi_range.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_range.cc	2010-08-11 16:49:34 +0000
@@ -56,8 +56,6 @@
   if (fast_mi_readinfo(info))
     return(HA_POS_ERROR);
   info->update&= (HA_STATE_CHANGED+HA_STATE_ROW_CHANGED);
-  if (info->s->concurrent_insert)
-    pthread_rwlock_rdlock(&info->s->key_root_lock[inx]);
 
   switch(info->s->keyinfo[inx].key_alg){
   case HA_KEY_ALG_BTREE:
@@ -74,8 +72,6 @@
       res=HA_POS_ERROR;
   }
 
-  if (info->s->concurrent_insert)
-    pthread_rwlock_unlock(&info->s->key_root_lock[inx]);
   fast_mi_writeinfo(info);
 
   return(res);

=== modified file 'plugin/myisam/mi_rkey.cc'
--- plugin/myisam/mi_rkey.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_rkey.cc	2010-08-11 16:49:34 +0000
@@ -68,9 +68,6 @@
   if (fast_mi_readinfo(info))
     goto err;
 
-  if (share->concurrent_insert)
-    pthread_rwlock_rdlock(&share->key_root_lock[inx]);
-
   nextflag=myisam_read_vec[search_flag];
   use_key_length=pack_key_length;
   if (!(nextflag & (SEARCH_FIND | SEARCH_NO_FIND | SEARCH_LAST)))
@@ -135,8 +132,6 @@
       if (res == 2)
       {
         info->lastpos= HA_OFFSET_ERROR;
-        if (share->concurrent_insert)
-          pthread_rwlock_unlock(&share->key_root_lock[inx]);
         return((errno= HA_ERR_KEY_NOT_FOUND));
       }
       /*
@@ -151,8 +146,6 @@
       }
     }
   }
-  if (share->concurrent_insert)
-    pthread_rwlock_unlock(&share->key_root_lock[inx]);
 
   /* Calculate length of the found key;  Used by mi_rnext_same */
   if ((keyinfo->flag & HA_VAR_LENGTH_KEY) && last_used_keyseg &&

=== modified file 'plugin/myisam/mi_rnext.cc'
--- plugin/myisam/mi_rnext.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_rnext.cc	2010-08-11 16:49:34 +0000
@@ -38,8 +38,6 @@
 
   if (fast_mi_readinfo(info))
     return(errno);
-  if (info->s->concurrent_insert)
-    pthread_rwlock_rdlock(&info->s->key_root_lock[inx]);
   changed=_mi_test_if_changed(info);
   if (!flag)
   {
@@ -83,17 +81,12 @@
     }
     if (!error && res == 2)
     {
-      if (info->s->concurrent_insert)
-        pthread_rwlock_unlock(&info->s->key_root_lock[inx]);
       info->lastpos= HA_OFFSET_ERROR;
       return(errno= HA_ERR_END_OF_FILE);
     }
   }
 
-  if (info->s->concurrent_insert)
-    pthread_rwlock_unlock(&info->s->key_root_lock[inx]);
-
-	/* Don't clear if database-changed */
+  /* Don't clear if database-changed */
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
   info->update|= HA_STATE_NEXT_FOUND;
 

=== modified file 'plugin/myisam/mi_rnext_same.cc'
--- plugin/myisam/mi_rnext_same.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_rnext_same.cc	2010-08-11 16:49:34 +0000
@@ -37,9 +37,6 @@
   if (fast_mi_readinfo(info))
     return(errno);
 
-  if (info->s->concurrent_insert)
-    pthread_rwlock_rdlock(&info->s->key_root_lock[inx]);
-
   switch (keyinfo->key_alg)
   {
     case HA_KEY_ALG_BTREE:
@@ -69,9 +66,7 @@
           break;
       }
   }
-  if (info->s->concurrent_insert)
-    pthread_rwlock_unlock(&info->s->key_root_lock[inx]);
-	/* Don't clear if database-changed */
+  /* Don't clear if database-changed */
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
   info->update|= HA_STATE_NEXT_FOUND | HA_STATE_RNEXT_SAME;
 

=== modified file 'plugin/myisam/mi_rprev.cc'
--- plugin/myisam/mi_rprev.cc	2009-12-23 08:01:21 +0000
+++ plugin/myisam/mi_rprev.cc	2010-08-11 16:49:34 +0000
@@ -37,8 +37,6 @@
   if (fast_mi_readinfo(info))
     return(errno);
   changed=_mi_test_if_changed(info);
-  if (share->concurrent_insert)
-    pthread_rwlock_rdlock(&share->key_root_lock[inx]);
   if (!flag)
     error=_mi_search_last(info, share->keyinfo+inx,
 			  share->state.key_root[inx]);
@@ -64,7 +62,6 @@
 	  break;
       }
     }
-    pthread_rwlock_unlock(&share->key_root_lock[inx]);
   }
   info->update&= (HA_STATE_CHANGED | HA_STATE_ROW_CHANGED);
   info->update|= HA_STATE_PREV_FOUND;

=== modified file 'plugin/myisam/mi_rsame.cc'
--- plugin/myisam/mi_rsame.cc	2010-02-04 08:14:46 +0000
+++ plugin/myisam/mi_rsame.cc	2010-08-11 16:49:34 +0000
@@ -49,13 +49,9 @@
     info->lastinx=inx;
     info->lastkey_length=_mi_make_key(info,(uint) inx,info->lastkey,record,
 				      info->lastpos);
-    if (info->s->concurrent_insert)
-      pthread_rwlock_rdlock(&info->s->key_root_lock[inx]);
     _mi_search(info,info->s->keyinfo+inx,info->lastkey, USE_WHOLE_KEY,
                SEARCH_SAME,
                info->s->state.key_root[inx]);
-    if (info->s->concurrent_insert)
-      pthread_rwlock_unlock(&info->s->key_root_lock[inx]);
   }
 
   if (!(*info->read_record)(info,info->lastpos,record))

=== modified file 'plugin/myisam/mi_write.cc'
--- plugin/myisam/mi_write.cc	2010-08-04 19:53:02 +0000
+++ plugin/myisam/mi_write.cc	2010-08-11 16:49:34 +0000
@@ -100,24 +100,18 @@
                                   is_tree_inited(&info->bulk_insert[i])));
       if (local_lock_tree)
       {
-	pthread_rwlock_wrlock(&share->key_root_lock[i]);
 	share->keyinfo[i].version++;
       }
       {
         if (share->keyinfo[i].ck_insert(info,i,buff,
 			_mi_make_key(info,i,buff,record,filepos)))
         {
-          if (local_lock_tree)
-            pthread_rwlock_unlock(&share->key_root_lock[i]);
           goto err;
         }
       }
 
       /* The above changed info->lastkey2. Inform mi_rnext_same(). */
       info->update&= ~HA_STATE_RNEXT_SAME;
-
-      if (local_lock_tree)
-        pthread_rwlock_unlock(&share->key_root_lock[i]);
     }
   }
   if (share->calc_checksum)
@@ -166,22 +160,13 @@
     {
       if (mi_is_key_active(share->state.key_map, i))
       {
-	bool local_lock_tree= (lock_tree &&
-                                  !(info->bulk_insert &&
-                                    is_tree_inited(&info->bulk_insert[i])));
-	if (local_lock_tree)
-	  pthread_rwlock_wrlock(&share->key_root_lock[i]);
 	{
 	  uint32_t key_length=_mi_make_key(info,i,buff,record,filepos);
 	  if (_mi_ck_delete(info,i,buff,key_length))
 	  {
-	    if (local_lock_tree)
-	      pthread_rwlock_unlock(&share->key_root_lock[i]);
 	    break;
 	  }
 	}
-	if (local_lock_tree)
-	  pthread_rwlock_unlock(&share->key_root_lock[i]);
       }
     }
   }
@@ -764,7 +749,6 @@
   case free_init:
     if (param->info->s->concurrent_insert)
     {
-      pthread_rwlock_wrlock(&param->info->s->key_root_lock[param->keynr]);
       param->info->s->keyinfo[param->keynr].version++;
     }
     return 0;
@@ -775,8 +759,6 @@
     return _mi_ck_write_btree(param->info,param->keynr,lastkey,
 			      keylen - param->info->s->rec_reflength);
   case free_end:
-    if (param->info->s->concurrent_insert)
-      pthread_rwlock_unlock(&param->info->s->key_root_lock[param->keynr]);
     return 0;
   }
   return -1;

=== modified file 'plugin/myisam/myisam_priv.h'
--- plugin/myisam/myisam_priv.h	2010-08-10 18:41:37 +0000
+++ plugin/myisam/myisam_priv.h	2010-08-11 16:49:34 +0000
@@ -233,8 +233,6 @@
     temporary,delay_key_write,
     concurrent_insert;
   drizzled::THR_LOCK lock;
-  pthread_mutex_t intern_lock;		/* Locking for use with _locking */
-  pthread_rwlock_t *key_root_lock;
   drizzled::internal::my_off_t mmaped_length;
   uint32_t     nonmmaped_inserts;           /* counter of writing in non-mmaped
                                            area */

